#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdarg.h>

#include "utils.h"

void extractFinalResult() {

    struct result *curResult = firstResult;
    unsigned char *charArray;
    unsigned char lastChar;
    uint8_t *countArray;
    uint8_t lastCount;
    struct result *tempResult;

    if (curResult -> resultLength == 0) {
        return;
    }

    while (curResult != NULL) {
        charArray = curResult -> charArray;
        countArray = curResult -> countArray;
        if (curResult -> resultLength > 1) {
            if (curResult == firstResult) {
                fprintf(stdout, "%c%c", charArray[0], countArray[0]);
            }
            else if (charArray[0] == lastChar) {
                fprintf(stdout, "%c%c", lastChar, lastCount + countArray[0]);
            }
            else {
                fprintf(stdout, "%c%c%c%c", lastChar, lastCount, charArray[0], countArray[0]);
            }
            for (int i = 1; i < curResult -> resultLength - 1; i ++) {
                fprintf(stdout, "%c%c", charArray[i], countArray[i]);
            }
        }
        lastChar = charArray[curResult -> resultLength - 1];
        lastCount = countArray[curResult -> resultLength - 1];
        tempResult = curResult -> nextResult;
        free(curResult -> charArray);
        free(curResult -> countArray);
        free(curResult);
        curResult = tempResult;
    }
    fprintf(stdout, "%c%c", lastChar, lastCount);
    fflush(stdout);

}
